SystemOrganization addCategory: #'Amber-Slime'!

RBBlockLintRule subclass: #AMSlimeBlockLintRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amber-Slime'!

AMSlimeBlockLintRule subclass: #AMDontCreateCategoriesInAmberRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amber-Slime'!

!AMDontCreateCategoriesInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 11:19'!
checkMethod: aContext
	((aContext compiledMethod refersToLiteral: #addCategory:) and: [ aContext parseTree references: #SystemOrganizer ])
		ifTrue: [ result addClass: aContext selectedClass selector: aContext selector ]! !

!AMDontCreateCategoriesInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 10:39'!
group
	^'Amber Portability'! !

!AMDontCreateCategoriesInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 10:40'!
name
	^ 'Class Categories'! !

!AMDontCreateCategoriesInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 11:19'!
rationale
	^ 'Amber creates class categories on the fly.'! !

AMSlimeBlockLintRule subclass: #AMNoClassVariablesInAmberRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amber-Slime'!

!AMNoClassVariablesInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 10:31'!
checkClass: aContext
	aContext selectedClass classPool isEmpty
		ifFalse: [ 
			result addClass: aContext selectedClass.
			result addSearchString: aContext selectedClass name ]! !

!AMNoClassVariablesInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 10:17'!
group
	^'Amber Portability'! !

!AMNoClassVariablesInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 10:18'!
name
	^'Class Variables'! !

!AMNoClassVariablesInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 10:44'!
rationale
	^ 'Amber does not support class variables.  It does support class Inst vars.'! !

!AMNoClassVariablesInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 10:38'!
resultClass
	^ RBClassEnvironment! !

AMSlimeBlockLintRule subclass: #AMNoPragmasInAmberRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amber-Slime'!

!AMNoPragmasInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 10:14'!
checkMethod: aContext 
	aContext compiledMethod pragmas do: [ :each |
		result 
			addClass: aContext selectedClass
			selector: aContext selector.
		result addSearchString: each keyword ]! !

!AMNoPragmasInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 10:13'!
group
	^'Amber Portability'! !

!AMNoPragmasInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 10:16'!
name
	^'Pragmas'! !

!AMNoPragmasInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 10:44'!
rationale
	^ 'Amber does not support pragmas/primitives.'! !

AMSlimeBlockLintRule subclass: #AMNoSharedPoolsInAmberRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amber-Slime'!

!AMNoSharedPoolsInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 10:37'!
checkClass: aContext
	aContext selectedClass sharedPools isEmpty
		ifFalse: [ result addClass: aContext selectedClass ]! !

!AMNoSharedPoolsInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 10:28'!
group
	^'Amber Portability'! !

!AMNoSharedPoolsInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 10:31'!
name
	^ 'SharedPools'! !

!AMNoSharedPoolsInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 10:44'!
rationale
	^ 'Amber does not support shared pools.'! !

!AMNoSharedPoolsInAmberRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 10:39'!
resultClass
	^ RBClassEnvironment! !

!AMSlimeBlockLintRule classSide methodsFor: 'testing' stamp: 'PaulDeBruicker 1/12/2012 08:56'!
isVisible
	^ self name ~= #AMSlimeBlockLintRule! !

!AMSlimeBlockLintRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 08:57'!
group
	^ 'Amber Portability'! !

AMSlimeBlockLintRule subclass: #AMSmalltalkGlobalRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amber-Slime'!

!AMSmalltalkGlobalRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 13:54'!
checkMethod: aContext
	(aContext parseTree references: #Smalltalk)
		ifTrue: [ result addClass: aContext selectedClass selector: aContext selector ]! !

!AMSmalltalkGlobalRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 13:04'!
group
	^'Amber Portability'! !

!AMSmalltalkGlobalRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 13:04'!
name
	^ 'No Globals'! !

!AMSmalltalkGlobalRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 13:04'!
rationale
	^ 'Amber does not have globals so all references to Smalltalk must be changed to Smalltalk current.'! !

RBTransformationRule subclass: #AMSlimeTransformationRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amber-Slime'!

AMSlimeTransformationRule subclass: #AMCharacterLiteralToStringRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amber-Slime'!

!AMCharacterLiteralToStringRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 09:02'!
group
	^'Amber Compatability'! !

!AMCharacterLiteralToStringRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 10:04'!
initialize
	super initialize.
	self rewriteRule
		replace: '`#literal' 
			withValueFrom: [ :node |
				RBLiteralNode value: (node value asString) ]
			when: [ :node | 
				node value isCharacter
					] ! !

!AMCharacterLiteralToStringRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 11:36'!
name
	^ 'Character Literal To String'! !

!AMCharacterLiteralToStringRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 09:03'!
rationale
	^ 'Amber does not have the Character class.'! !

!AMSlimeTransformationRule classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 09:32'!
isVisible
	^ self name ~= #AMSlimeTransformationRule! !

AMSlimeTransformationRule subclass: #AMSmalltalkToSmalltalkCurrentRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amber-Slime'!

!AMSmalltalkToSmalltalkCurrentRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 11:35'!
group
	^'Amber Compatability'! !

!AMSmalltalkToSmalltalkCurrentRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 13:50'!
initialize
	super initialize.
	self rewriteRule
		replace: 'Smalltalk `@message: ``@args '
		with: 'Smalltalk current  `@message: ``@args'
		when: [ :node | (node uses: #Smalltalk) and: [ node selector ~= #current ] ]! !

!AMSmalltalkToSmalltalkCurrentRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 11:35'!
name
	^ 'Smalltalk to Smalltalk current'! !

!AMSmalltalkToSmalltalkCurrentRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 1/12/2012 13:02'!
rationale
	^ 'Amber does not have globals so you need to change all references to Smalltalk to Smallltalk current.'! !
